<template>
  <div class="d-flex flex-column">
    <span v-if="!viewMode">Заполните 4 варианта и выберите несколько вариантов:</span>
    <div class="d-flex flex-column">
      <ValidationProvider
        name="checkbox-group"
        rules="required"
        v-slot="{ errors }"
      >
        {{ errors }}
        <div class="d-flex align-center" v-for="(variant, i) in innerConfig.variants" :key="variant.value">
          <v-checkbox :value="variant.value" v-model="innerValue"></v-checkbox>
          <ValidationProvider
            style="width: 100%"
            :name="`text-${variant.value}`"
            rules="required"
            v-slot="{ errors }"
          >
            <v-text-field
              label="Текст варианта"
              :key="variant.value"
              v-model="innerConfig.variants[i].text"
              :error-messages="errors"
              required
            ></v-text-field>
          </ValidationProvider>
        </div>
      </ValidationProvider>
    </div>
  </div>
</template>
<script>
import QuestionMixin from "@/mixins/Question.js";
import { extend } from "vee-validate";
import { required } from "vee-validate/dist/rules";
export default {
  mixins: [QuestionMixin],
  data() {
    return {
      innerValue: []
    }
  },
  watch: {
    variants: {
      deep: true,
      handler(v) {
        this.innerConfig.variants = v;
      }
    },
    innerValue: {
      deep: true,
      handler(v) {
        this.innerConfig.result = v;
        this.$emit('input', this.innerConfig);
      }
    }
  },
  created() {
    if (!Array.isArray(this.innerConfig.result)) {
      this.innerConfig.result = [];
    }
    if (this.innerConfig.variants.length === 0) {
      this.innerConfig.variants = Array(4).fill({}).map((_, i) => ({ value: i + 1, text: ''}));
    }
    extend("checkbox", {
      ...required,
      message: "Выбирите правильные ответы"
    });
  },
};
</script>